<template>
  <div class="box-main shadow-2">
    <div class="row q-px-md justify-between q-pt-md">
      <div class="text-h6">
        {{ data.sensorName }} - {{ data.sensorBoxName }}
      </div>
      <div class="row">
        <div class="q-mr-md cursor-pointer">
          <q-icon
            name="fa-solid fa-trash-can"
            color="secondary"
            @click="deleteSensor()"
          />
        </div>
        <div class="q-mr-md cursor-pointer">
          <q-icon
            name="fa-solid fa-pen-to-square"
            color="secondary"
            @click="
              editSensor(
                data.sensorID,
                data.sensorName,
                data.sensorType,
                data.sensorBoxID
              )
            "
          />
        </div>
        <div class="q-mr-md cursor-pointer">
          <q-icon
            name="fa-regular fa-image"
            color="secondary"
            @click="openPictureDia()"
          />
        </div>
        <div>
          <div
            class="onlineBtn"
            v-if="data.online"
            @click="setStatus(0, data.sensorID)"
          >
            online
          </div>
          <div class="offlineBtn" v-else @click="setStatus(1, data.sensorID)">
            offline
          </div>
        </div>
      </div>
    </div>
    <div class="row q-px-md justify-between">
      <div>{{ data.typeName }}</div>
      <div class="cursor-pointer" @click="addAxisBtn()">
        <u>Add new axis</u>
      </div>
    </div>
    <div class="picbox">
      <div v-if="data.picture == 0">No picture</div>
      <div v-else>
        <img :src="picShow(data.sensorID)" alt="" width="100%" />
      </div>
    </div>
    <div class="row q-px-md axisbar">
      <div style="width: 8%" align="center">Axis</div>
      <div class="col" align="center">Unit</div>
      <div style="width: 12%" align="center">factor</div>
      <div style="width: 15%" align="center">min limit</div>
      <div style="width: 15%" align="center">max limit</div>
      <div style="width: 12%" align="center">column</div>
      <div style="width: 10%" align="center">edit</div>
      <div style="width: 12%" align="center">delete</div>
    </div>
    <div
      class="row q-px-md contentbar"
      v-for="(item2, index2) in data.sensor"
      :key="index2"
    >
      <div style="width: 8%" align="center">{{ item2.axis }}</div>
      <div class="col" align="center" v-html="item2.unit"></div>
      <div style="width: 12%" align="center">{{ item2.factor }}</div>
      <div style="width: 15%" align="center">
        {{ item2.minLimit == null ? "-" : item2.minLimit }}
      </div>
      <div style="width: 15%" align="center">
        {{ item2.maxLimit == null ? "-" : item2.maxLimit }}
      </div>
      <div style="width: 12%" align="center">{{ item2.columnRead }}</div>
      <div
        style="width: 10%"
        align="center"
        class="cursor-pointer"
        @click="editAxis(item2)"
      >
        <u>edit</u>
      </div>
      <div
        style="width: 12%"
        align="center"
        class="cursor-pointer"
        @click="delAxis(item2.id)"
      >
        <u>delete</u>
      </div>
    </div>

    <!-- Dialog edit sensor -->
    <q-dialog v-model="editSensorDia" persistent>
      <q-card class="editSensor q-pu-sm">
        <div class="text-h6 q-px-md">Edit sensor</div>
        <hr />
        <div class="row">
          <div class="col-3 q-pl-md q-pt-md">name</div>
          <div class="col-8">
            <q-input v-model="sensorData.name" dense />
          </div>
        </div>
        <div class="row">
          <div class="col-3 q-pl-md q-pt-md">type</div>
          <div class="col-8">
            <q-select
              v-model="sensorData.type"
              :options="sensorTypeOption"
              dense
              emit-value
              map-options
            />
          </div>
        </div>
        <div class="row">
          <div class="col-3 q-pl-md q-pt-md">box</div>
          <div class="col-8">
            <q-select
              v-model="sensorData.box"
              :options="sensorBox"
              dense
              emit-value
              map-options
            />
          </div>
        </div>
        <div class="row justify-center q-pt-md">
          <div>
            <q-btn
              label="cancel"
              outline
              class="btn"
              @click="closeEditSensor()"
            />
          </div>
          <div style="width: 40px"></div>
          <div>
            <q-btn
              label="Save"
              class="btn"
              color="secondary"
              @click="saveEditSensor()"
            />
          </div>
        </div>
      </q-card>
    </q-dialog>

    <!-- Dialog รูปภาพ -->
    <!-- add new picture -->
    <q-dialog v-model="picBoxDia" persistent>
      <q-card class="picBoxDia q-py-sm">
        <div class="text-h6 q-px-md">Add new picture (900 x 480px)</div>
        <hr />
        <div class="row">
          <div style="width: 100px" class="q-pa-md">Filename:</div>
          <div class="col q-pr-xl">
            <q-input
              @input="
                (val) => {
                  pic.fileName = val[0];
                }
              "
              type="file"
              dense
            />
          </div>
        </div>
        <div class="row justify-center q-pt-md">
          <div>
            <q-btn
              label="cancel"
              outline
              class="btn"
              @click="closePictureBtn()"
            />
          </div>
          <div style="width: 40px"></div>
          <div>
            <q-btn
              label="Save"
              class="btn"
              color="secondary"
              @click="savePictureBtn()"
            />
          </div>
        </div>
      </q-card>
    </q-dialog>
    <!-- Add axis -->
    <q-dialog v-model="addAxisDia" persistent>
      <q-card class="addAxisDia q-pa-md">
        <div class="row justify-between">
          <div class="text-h6">{{ data.sensorName }}</div>
          <div class="text-grey">Add new axis</div>
        </div>
        <hr />
        <div class="row justify-center">
          <div style="width: 120px" class="q-pt-md">Axis</div>
          <div style="width: 100px">
            <q-select :options="axisOption" v-model="axis.axis" dense />
          </div>
        </div>
        <div class="row justify-center">
          <div style="width: 120px" class="q-pt-md">Unit</div>
          <div style="width: 100px">
            <q-input v-model="axis.unit" dense />
          </div>
        </div>
        <div class="row justify-center">
          <div style="width: 120px" class="q-pt-md">Factor</div>
          <div style="width: 100px">
            <q-input v-model="axis.factor" dense type="number" />
          </div>
        </div>
        <div class="row justify-center">
          <div style="width: 120px" class="q-pt-md">Column</div>
          <div style="width: 100px">
            <q-input v-model="axis.column" dense type="number" />
          </div>
        </div>
        <div class="row justify-center">
          <div style="width: 120px" class="q-pt-md">Min limit</div>
          <div style="width: 100px">
            <q-input v-model="axis.minLimit" dense />
          </div>
        </div>
        <div class="row justify-center">
          <div style="width: 120px" class="q-pt-md">Max limit</div>
          <div style="width: 100px">
            <q-input v-model="axis.maxLimit" dense />
          </div>
        </div>
        <div class="row justify-center q-pt-md">
          <div>
            <q-btn label="cancel" outline class="btn" @click="closeAxisBtn()" />
          </div>
          <div style="width: 40px"></div>
          <div>
            <q-btn
              label="Save"
              class="btn"
              color="secondary"
              @click="saveAxisBtn()"
            />
          </div>
        </div>
      </q-card>
    </q-dialog>
    <!-- Edit axis -->
    <q-dialog v-model="editAxisDia" persistent>
      <q-card class="addAxisDia q-pa-md">
        <div class="row justify-between">
          <div class="text-h6">{{ data.sensorName }}</div>
          <div class="text-grey">edit axis</div>
        </div>
        <hr />
        <div class="row justify-center">
          <div style="width: 120px" class="q-pt-md">Axis</div>
          <div style="width: 100px">
            <q-select :options="axisOption" v-model="editAxisData.axis" dense />
          </div>
        </div>
        <div class="row justify-center">
          <div style="width: 120px" class="q-pt-md">Unit</div>
          <div style="width: 100px">
            <q-input v-model="editAxisData.unit" dense />
          </div>
        </div>
        <div class="row justify-center">
          <div style="width: 120px" class="q-pt-md">Factor</div>
          <div style="width: 100px">
            <q-input v-model="editAxisData.factor" dense type="number" />
          </div>
        </div>
        <div class="row justify-center">
          <div style="width: 120px" class="q-pt-md">Column</div>
          <div style="width: 100px">
            <q-input v-model="editAxisData.columnRead" dense type="number" />
          </div>
        </div>
        <div class="row justify-center">
          <div style="width: 120px" class="q-pt-md">Min limit</div>
          <div style="width: 100px">
            <q-input v-model="editAxisData.minLimit" dense />
          </div>
        </div>
        <div class="row justify-center">
          <div style="width: 120px" class="q-pt-md">Max limit</div>
          <div style="width: 100px">
            <q-input v-model="editAxisData.maxLimit" dense />
          </div>
        </div>
        <div class="row justify-center q-pt-md">
          <div>
            <q-btn
              label="cancel"
              outline
              class="btn"
              @click="closeEditAxisBtn()"
            />
          </div>
          <div style="width: 40px"></div>
          <div>
            <q-btn
              label="Save"
              class="btn"
              color="secondary"
              @click="saveEditAxisBtn()"
            />
          </div>
        </div>
      </q-card>
    </q-dialog>
  </div>
</template>

<script>
import axios from "axios";
export default {
  props: ["data", "sensorBox"],
  data() {
    return {
      editSensorDia: false,
      sensorTypeOption: [],
      sensorData: {
        id: "",
        name: "",
        type: "",
        box: "",
      },

      picBoxDia: false,
      pic: {
        fileName: null,
      },
      addAxisDia: false,
      axis: {
        axis: "x",
        unit: "",
        factor: "1",
        column: "",
        minLimitStatus: false,
        minLimit: "",
        maxLimitStatus: false,
        maxLimit: "",
      },
      axisOption: ["x", "y", "z"],

      editAxisDia: false,
      editAxisData: {
        axis: "x",
        unit: "",
        factor: "1",
        columnRead: "",
        minLimitStatus: false,
        minLimit: "",
        maxLimitStatus: false,
        maxLimit: "",
      },
    };
  },
  methods: {
    async saveEditAxisBtn() {
      let url = this.apiPath + "editAxis.php";
      let res = await axios.post(url, JSON.stringify(this.editAxisData));
      this.$emit("refeshBox");
    },
    closeEditAxisBtn() {
      this.editAxisDia = false;
    },
    editAxis(item) {
      this.editAxisDia = true;
      this.editAxisData = item;
    },
    async delAxis(id) {
      this.$q
        .dialog({
          title: "Confirm",
          message: "Would you like to delete this axis?",
          cancel: true,
          persistent: true,
        })
        .onOk(async () => {
          let dataSend = {
            id: id,
          };
          let url = this.apiPath + "delAxis.php";
          let res = await axios.post(url, JSON.stringify(dataSend));
          this.$emit("refeshBox");
        })
        .onCancel(() => {
          // console.log('>>>> Cancel')
        });
    },
    async saveAxisBtn() {
      if (this.axis.unit.length == 0 || this.axis.column.length == 0) {
        this.redNotify("Please input all field");
        return;
      }

      if (this.axis.minLimit.length == 0) {
        this.redNotify("Please input all field");
        return;
      }

      if (this.axis.maxLimit.length == 0) {
        this.redNotify("Please input all field");
        return;
      }

      let dataSend = {
        ...this.axis,
        sensorID: this.data.sensorID,
      };
      let url = this.apiPath + "saveAxis.php";
      let res = await axios.post(url, JSON.stringify(dataSend));
      this.addAxisDia = false;
      this.$emit("refeshBox");
    },
    closeAxisBtn() {
      this.addAxisDia = false;
    },
    addAxisBtn() {
      this.addAxisDia = true;
    },
    // Delete btn
    deleteSensor() {
      this.$q
        .dialog({
          title: "Confirm",
          message: "Would you like to delete this sensor?",
          cancel: true,
          persistent: true,
        })
        .onOk(async () => {
          let dataSend = {
            id: this.data.sensorID,
          };
          let url = this.apiPath + "deleteSensor.php";
          let res = await axios.post(url, JSON.stringify(dataSend));
          this.$emit("refeshBox");
        });
    },
    // edit btn
    editSensor(id, name, typeData, boxID) {
      this.editSensorDia = true;
      this.sensorData.id = id;
      this.sensorData.name = name;
      this.sensorData.type = typeData;
      this.sensorData.box = Number(boxID);
    },
    closeEditSensor() {
      this.editSensorDia = false;
    },
    async saveEditSensor() {
      let url = this.apiPath + "editSensorBox.php";
      let res = await axios.post(url, JSON.stringify(this.sensorData));
      this.$emit("refeshBox");
      this.editSensorDia = false;
    },
    // Picture btn
    openPictureDia() {
      this.picBoxDia = true;
    },
    async savePictureBtn() {
      const formData = new FormData();
      formData.append("id", this.data.sensorID);
      formData.append("fileName", this.pic.fileName.name);
      formData.append("fileNameData", this.pic.fileName);
      const headers = { "Content-Type": "multipart/form-data" };
      let res2 = await axios.post(
        this.apiPath + "savePicSensor.php",
        formData,
        { headers }
      );
      this.picBoxDia = false;
      this.$emit("refeshBox");
    },
    closePictureBtn() {
      this.picBoxDia = false;
    },
    // online offline btn
    async setStatus(status, id) {
      let dataSend = {
        status: status,
        sensorID: id,
      };
      let url = this.apiPath + "setSensorStatus.php";
      let res = await axios.post(url, JSON.stringify(dataSend));
      this.$emit("refeshBox");
    },

    async loadSensorTypeList() {
      this.sensorTypeOption = [];
      let url = this.apiPath + "loadSensorType.php";
      let res = await axios.get(url);
      res.data.forEach((x) => {
        let temp = {
          value: x.id,
          label: x.typeName,
        };
        this.sensorTypeOption.push(temp);
      });
      this.sensorData.type = this.sensorTypeOption[0].value;
    },

    picShow(id) {
      return (
        this.apiPath +
        "sensor/" +
        id +
        ".jpg?" +
        Math.floor(Math.random() * (999 - 100 + 1) + 100)
      );
    },
  },

  mounted() {
    this.loadSensorTypeList();
  },
};
</script>

<style lang="scss" scoped>
.btn {
  width: 150px;
}
.box-main {
  width: 90%;
  height: 420px;
  background-color: white;
  margin: auto;
  margin-bottom: 30px;
}
.onlineBtn {
  background-color: #287377;
  color: white;
  border-radius: 20px;
  width: 60px;
  text-align: center;
  cursor: pointer;
}
.offlineBtn {
  background-color: #ee4873;
  color: white;
  border-radius: 20px;
  width: 60px;
  text-align: center;
  cursor: pointer;
}
.picbox {
  height: 250px;
  width: 90%;
  margin: auto;
  text-align: center;
  line-height: 200px;
}
.axisbar {
  background-color: #287377;
  color: white;
  font-size: 12px;
  padding-top: 5px;
  padding-bottom: 5px;
}
.contentbar {
  font-size: 12px;
}
.picBoxDia {
  widows: 500px;
  min-width: 500px;
  height: 180px;
}
.editSensor {
  widows: 500px;
  min-width: 500px;
  height: 240px;
}
.addAxisDia {
  widows: 500px;
  min-width: 500px;
  height: 380px;
}
</style>
